const path = require('path')
const fs = require('fs')
const shell = require("shelljs");
const download = require('download-git-repo')


module.exports = {
    /**
     *  检查路径是否存在，不存在就创建一下
     * @param {*} filePath 
     */
    pathCheckAndMkdir(filePath) {
        if (!fs.existsSync(filePath)) {
            shell.exec("mkdir -p " + filePath)
        }
    },
    /**
     * 生成文件
     * @param {} filePath 
     */
    touchFile(filePath) {
        if(!fs.existsSync(filePath)) {
            shell.exec("touch "+ filePath)
        }
    },

    checkFileExist(filePath){
        if (!fs.existsSync(filePath)) {
            return false
        } else {
            return true
        }
    },
    /**
     * 移动文件
     * @param { 文件 } fileName
     * @param { 文件当前路径} fromPath 
     * @param { 移动到路径} toPath 
     */
    move(fileName, fromPath , toPath) {
        if (!fs.existsSync(fromPath + '/' + fileName )) {
            console.error('需要移动的文件不存在')
            return false
        } 

        shell.exec('mv ' + fromPath + '/' + fileName + ' ' + toPath)
        return true
    },

    /**
     * 获取该库根路径
     */
    getToolBasePath(){
        return  path.resolve(__dirname, '..')
    },

    /**
     * 获取当前脚本路径
     * @param {*} str 
     */
    getCurrentPath() {
        return path.resolve(process.cwd());
    },

    /**
     * 首字母大写
     * @param {*} str 
     */
    firstUpperCase(str) {
        return str.toLowerCase().replace(/( |^)[a-z]/g, (L) => L.toUpperCase());
    },

    /**
     * 读取json配置文件
     */
    readJsonFromJsonFile(jsonFile) {
        return JSON.parse(JSON.stringify(require(jsonFile)))
    }

}
