const StringUtil = require('./StringUtil')
var util = require('util');
var stream = require('stream');
util.inherits(templateTransform, stream.Transform);

function templateTransform(opt) {
    stream.Transform.call(this, opt);
}

templateTransform.prototype.rules = [];

/**
 * 重写替换规则
 * @param {*} chunk 
 * @param {*} encoding 
 * @param {*} callback 
 */
templateTransform.prototype._transform = function(chunk, encoding, callback){
    let str = chunk.toString('utf8')
    let rules = this.rules
    if(rules.length > 0) {
        rules.map(rule=> {
            var regex = new RegExp('{{'+rule.name+'}}', 'g');
            str = str.replace(regex, rule.replace_str)
            // 判断是否需要更改首字母大写的规则
            var firstUpperCase_regex = new RegExp('{{'+rule.name+'_firstUpperCase'+'}}', 'g')
            str = str.replace(firstUpperCase_regex, StringUtil.firstUpperCase(rule.replace_str))
            // 判断是否需要更改首字母小写的规则
            var firstLowerCase_regex = new RegExp('{{'+rule.name+'_firstLowerCase'+'}}', 'g')
            str = str.replace(firstLowerCase_regex, StringUtil.firstLowerCase(rule.replace_str))
            // 判断是否需要全部小写的规则
            var toLowerCase_regex = new RegExp('{{'+rule.name+'_toLowerCase'+'}}', 'g')
            str = str.replace(toLowerCase_regex, StringUtil.toLowerCase(rule.replace_str))
            // 判断是否需要全部大写的规则
            var toUpperCase_regex = new RegExp('{{'+rule.name+'_toUpperCase'+'}}', 'g')
            str = str.replace(toUpperCase_regex, StringUtil.toUpperCase(rule.replace_str))
            
        })
    }
    var data = new Buffer(Buffer.byteLength(str, 'utf8'))
    data.write(str, 0)

    this.push(data);
    callback();
}

/**
 * 继承父类
 * @param {*} cb 
 */
templateTransform.prototype._flush = function(cb){
    cb();
}

module.exports = templateTransform