/**
 * 用来根据地址来生成项目
 */
const fileUtil = require('../../lib/fileUtil')
const StringUtil = require('../../lib/StringUtil')
const logger = require('../../lib/logger')
const download = require('download-git-repo')
const program = require('commander')


const gitRepoJson = fileUtil.readJsonFromJsonFile(fileUtil.getToolBasePath()+'/git.json')
// 处理参数
// 列出所有列表
if(program.list && program.list == 'git') {
    if(gitRepoJson.repos && gitRepoJson.repos.length > 0) {
        gitRepoJson.repos.map(res => {
            logger.info(res.name, res.url)
        })
    } else {
        logger.fatal('暂无可用git库')
    }
    process.exit(0)
}

// 下载git并立项
let projectName = process.argv[3]
if(!projectName) {
    logger.fatal("请输入要初始化的项目名（如react-native-starter#dev，后面不写则为master分支，tool g p -l git 查看所有项目）")
}

const toProjectName = process.argv[4]
if(!toProjectName) {
    logger.fatal("请输入要生成的项目名）")
}

/**
 * gitUrl 
 * projectName
 * branch
 */
let gitUrl = ''
let projectNameTmpList = projectName.split("#");
projectName = projectNameTmpList[0]
const branch = projectNameTmpList[1]?projectNameTmpList[1]:'master'
gitRepoJson.repos.map(res => {
    if(projectName == res.name) {
        gitUrl = res.url
    }
})


download(`direct:${gitUrl}#${branch}`, toProjectName, { clone: true }, function (err) {
  console.log(err ? 'Error' : 'Success')
})





